<template>
  <div id="teacher_class_index_wrapper" class="bt-container">
    <h2 class="page-title">실시간 화상 토론</h2>
    <span style="display:inline-block; width: 200px; text-align:center; position: relative" :key="index">
      <video controls width="100%" ref="myVideo"/>
    </span>
    <template v-for="(index) in 10">
      <span style="display:inline-block; width: 200px; text-align:center; position: relative" :key="index">
        <video controls :ref='"userVideo"+index'/>
      </span>
    </template>
  </div>
</template>

<script>
import lectureService from '../../services/lectureService';
import utils from '../../utils';

export default {
  name: 'RealtimeWebcamLecture',
  data() {
    return {
      // webRTC
      pc: [],
      configuration: {
        iceServers: [
          {
            urls: 'stun:stun.l.google.com:19302',
          },
        ],
      },
      userVideoList: [],
      connectedUserMailList: [],
      myStream: undefined,
      hasVideo: false, // 접속자 시스템에 비디오, 오디오 여부
      hasAudio: false,
    };
  },
  async created() {
    const vm = this;
  },
  mounted() {
    const vm = this;

    vm.initiate(); // 캠, 마이크를 연결하여 stream 변수에 저장, 사용 준비

    // vm.sockets.subscribe('DISCUSSION', async (evt) => {
    //   const signal = JSON.parse(evt);

    //   let userIndex = -1;
    //   vm.connectedUserMailList.forEach((element, index) => {
    //     if (element === signal.from_email_id) userIndex = index;
    //   });


    // });

    // 방에 새로운 사람이 들어온 경우
    vm.sockets.subscribe('ENTER_NEW_DISCUSSOR', async (evt) => {
      console.log("@ENTER_NEW_DISCUSSOR");
      const signal = JSON.parse(evt);
      console.log('signal.from_email_id = ', signal.from_email_id);

      let userIndex = -1;
      vm.connectedUserMailList.forEach((element, index) => {
        if (element === signal.from_email_id) userIndex = index;
      })
      if (userIndex === -1) { // 아직 연결되지 않은 사람에게 온 경우
        console.log('아직 연결되지 않은 사람인 경우');
        // vm에 연결된 상대임을 저장
        vm.connectedUserMailList.push(signal.from_email_id);
        const index = vm.connectedUserMailList.length - 1;

        // 새로 온 사람에게 통화 요청을 보낸다.
        vm.pc[index] = new RTCPeerConnection(vm.configuration);
        const offer = await vm.pc[index].createOffer();
        await vm.pc[index].setLocalDescription(offer);

        vm.$socket.emit('CALL_VIDEO_DISCUSSION' , JSON.stringify({
          to_socket_id: signal.from_socket_id,
          from_email_id: utils.getEmailFromJwt(),
          offer,
        }));
      } else {
        console.log('이게 어찌된 일이요;;');
      }

      
    });

    // 영상 통화 요청 받았을 경우, 응답
    vm.sockets.subscribe('CALL_VIDEO_DISCUSSION', async (evt) => {
      console.log('@CALL_VIDEO_DISCUSSION');
      const signal = JSON.parse(evt);
 
      // if (signal.to == utils.getUserIdFromJwt()) { // 요청한 사람이 나인 경우
      //   console.log('요청한 사람이 나인 경우');
      //   return;
      // }

     let userIndex = -1;
      vm.connectedUserMailList.forEach((element, index) => {
        if (element === signal.from_email_id) userIndex = index;
      })
      if (userIndex === -1) { // 아직 연결되지 않은 사람에게 온 경우
        console.log('아직 연결되지 않은 사람인 경우');
        // vm에 연결된 상대임을 저장
        vm.connectedUserMailList.push(signal.from_email_id);
         // 새로운 연결 요청 처리
        await vm.processNewConnection(signal.offer, signal.from_socket_id, vm.connectedUserMailList.length - 1);
        // 연락된 사람 배열에 넣는다.
        vm.userVideoList.push(signal.from);
        return;
      }
      else { // 이미 연결된 사람에게 온 경우
        console.log('이미 연결된 사람인 경우');
        return;
      }
    });

    // 영상 통화 요청을 받았을 경우, 응답 을 받았을 경우 재응답
    vm.sockets.subscribe('REPLY_VIDEO_DISCUSSION', async (evt) => {
      console.log('@REPLY_VIDEO_DISCUSSION');
      const signal = JSON.parse(evt);
      // 어떤 pc에 연결됐는지 검색한다.
      console.log('vm.connectedUserMailList = ', vm.connectedUserMailList);
      console.log('signal.from_email_id = ', signal.from_email_id);
      let userIndex = -1;
      vm.connectedUserMailList.forEach((element, index) => {
        if (element === signal.from_email_id) userIndex = index;
      })
      console.log('userIndex = ', userIndex);
      if (userIndex === -1) { // 미등록 (에러)
        console.log("등록되지 않은 메일 주소에 대한 요청입니다.");
        return;
      }
      console.log('vm.pc[userIndex] = ' ,vm.pc[userIndex]);
      console.log('signal.answer = ', signal.answer);
      // 해당 pc에 수신 처리
      const remoteDesc = new RTCSessionDescription(signal.answer);
      await vm.pc[userIndex].setRemoteDescription(remoteDesc);
      console.log('해당 pc에 수신 처리 완료');
    });

    // Listen for remote ICE candidates and add them to the local RTCPeerConnection
      vm.sockets.subscribe('ICE_CANDIDATE', async (evt) => {
        console.log('@ICE_CANDIDATE');
        const signal = JSON.parse(evt);
        console.log('signal = ', signal);

        let userIndex = -1;
        vm.connectedUserMailList.forEach((element, index) => {
          if (element === signal.from_email_id) userIndex = index;
        })
        
        if (message.iceCandidate) {
          try {
            await vm.pc[userIndex].addIceCandidate(message.iceCandidate);
          } catch (e) {
            console.error('Error adding received ice candidate', e);
          }
        }
      });
    
    // 입장 사실 서버에 알림
    vm.$socket.emit('JOIN_VIDEO_DISCUSSION' , JSON.stringify({
      discussionRoomId: vm.discussionRoomId,
      from_email_id: utils.getEmailFromJwt(),
    }));
  },
  methods: {
    async initiate() { // 캠, 마이크를 연결하여 stream 변수에 저장, 사용 준비
      const vm = this;
      // 내가 통화 가능한 상태인지 파악한다.
      try {
        const devices = await navigator.mediaDevices.enumerateDevices();
        devices.forEach((device) => {
          if (device.kind === 'videoinput') {
            vm.hasVideo = true;
          }
          if (device.kind === 'audioinput') {
            vm.hasAudio = true;
          }
        });
        await navigator.mediaDevices.getUserMedia({
          audio: vm.hasAudio,
          video: vm.hasVideo,
        });
      } catch (err) {
        vm.$notify({
          title: vm.$t('NOTIFY.TITLE'),
          message: vm.$t('REALTIME.FAILED1'),
          type: 'warning',
        });
        return;
      }
      vm.myStream = await navigator.mediaDevices.getUserMedia({
        audio: vm.hasAudio,
        video: vm.hasVideo,
      });

      vm.$refs.myVideo.srcObject = vm.myStream;
      vm.$refs.myVideo.play();
    },
    async processNewConnection(offer, from_socket_id, userIndex) { // 새로운 연결 요청 처리    
      console.log('@processNewConnection');
      const vm = this;
      vm.pc[userIndex] = new RTCPeerConnection(vm.configuration);
      await vm.pc[userIndex].setRemoteDescription(new RTCSessionDescription(offer));
      const answer = await vm.pc[userIndex].createAnswer();
      await vm.pc[userIndex].setLocalDescription(answer);

      vm.pc[userIndex].addEventListener('icecandidate', event => {
        console.log('@icecandidate');
        if (event.candidate) {
          vm.$socket.emit('SEND_ICE_CANDIDATE', JSON.stringify({
            'from_email_id': utils.getEmailFromJwt(),
            'to_socket_id': from_socket_id,
            'new-ice-candidate': event.candidate,
          }));
        }
      });

      vm.pc[userIndex].addEventListener('connectionstatechange', event => {
        console.log('@connectionstatechange');
        if (peerConnection.connectionState === 'connected') {
          // Peers connected!
          console.log('peer connected!');
        } 
      });

      vm.pc[userIndex].addEventListener('onaddstream', (evt) => {
        console.log('@addStream');
        vm.userVideo[userIndex].srcObject = evt.stream;
        vm.userVideo[userIndex].play();
      });

      vm.$socket.emit('REPLY_VIDEO_DISCUSSION' , JSON.stringify({
        to_socket_id: from_socket_id,
        from_email_id: utils.getEmailFromJwt(),
        answer,
      }));
    },
    test() {
      console.log('test');
      const vm = this;
    },
  },
  computed: {
    lectureId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.lectureId, 10);
    },
    discussionRoomId() {
      const vm = this;
      return Number.parseInt(vm.$route.params.discussionRoomId, 10);
    },
  },
};
</script>